TSRs and More Product Information
---------------------------------
TSRs and More is a library of routines for Borland and Microsoft C/C++
programmers. It provides a swapping TSR management system that is easy
to use, inexpensive, and solid as a rock. You'll be able to write a
TSR that uses as little as 6K of normal DOS memory, regardless of the
actual size of the program. TSRs and More also provides:

     o Conventional TSRs and ISRs
     o Swapping Exec manager with a 3K kernel
     o Keyboard macro recording and playback
     o Huge data arrays with EMS, XMS, and virtual disk support
     o EMS and XMS memory management
     o Sorting, enhanced keyboard support, and more

The heart of the swapping TSR is a small kernel of code that remains
resident at all times to watch for hot keys or other events. When it
detects a request to pop up, it assures that system conditions are
safe, saves the program to be overwritten, and reads the remainder of
the TSR's code from EMS, XMS, or disk. When the TSR exits, the kernel
reverses the steps and returns control to the interrupted foreground
program. Applications that were previously too large to be TSRs will
now fit with ease. And they will have advanced features like the
ability to unload themselves, use configurable hot keys, prevent
loading twice, and much more.

A swapping Exec manager gives you a way to squeeze more code into the
640K DOS memory limit. It swaps most of the calling program to EMS,
XMS, or disk and gives all the free memory to the called program. With
TSRs and More you can accomplish this in only one line of code.

TSRs and More includes huge array classes that manage one or two
dimensional arrays of up to 32MB stored in EMS, XMS, or on disk. C++
template classes and operator overloading offer convenient access to
these arrays. Additional memory management tools provide
general-purpose access to EMS 4.0 and XMS memory.

TSRs and More also provides keyboard macros, support for enhanced
keyboards, DOS and BIOS access routines, and more.

TSRs and More includes a comprehensive 350 page manual, pop-up help,
and free technical support direct from the authors by telephone,
CompuServe, fax, and BBS. Plenty of working examples illustrate how to
use the functions. Sophisticated demo programs show how to make the
most of the library:

    o ALARM - a pop-up alarm program
    o CUTPASTE - inter-program cut and paste
    o IOLOG - a TSR for logging DOS I/O calls
    o POPDOS - a swapping TSR DOS shell
    o PSPOOL - print spooling using a TSR
    o SWAPDEMO - use Object Professional window classes in a TSR
    o SMACS - memory resident keyboard macro processor
    o PTIME - TSR to manage time and billings

TSRs and More requires Borland C++ 3.1 or later, Turbo C++ 3.1 or
later, Microsoft C/C++ 7.0, or Microsoft Visual C++ 1.0 or later.
Although the library uses C++ syntax internally, all but the huge
array functions can be called from either C or C++ applications.

Price and Shipping Info
-----------------------
TSRs and More costs $189, including complete source code.

TurboPower Software offers the Electronic Maintenance System, which
delivers maintenance updates at no charge other than the cost of a
download. More information about the EMS is available in the file
UPDATE.TXT.

For more information, or to order, call 1-800-333-4160 from 9am to 5pm
Mountain time, or write to TurboPower Software, P.O. Box 49009,
Colorado Springs, CO 80949. International customers call 719-260-9136.
Send faxes to 719-260-7151. Send CompuServe mail to 76004,2611. Visit
our CompuServe area in PCVENE section 1. We accept MasterCard, Visa,
American Express, Discover, a check in U.S. funds drawn on a U.S.
bank, or COD (within U.S. only).

  Version 1.0
  3.5" media only
  Weight 2.0 pounds
  Price $189 plus shipping
      FedEx Economy   $10     U.S. only                 (2 days)
      Airmail          $5     U.S. only                 (3-10 days)
      Airmail         $10     Canada only               (3-10 days)
      Airmail         $20     Elsewhere                 (7-21 days)
